Loading...
Searching...
No Matches
hueplusplus::sensors::ZGPSwitch Class Reference

ZigBee Green Power sensor for button presses. More...

`#include <hueplusplus/ZLLSensors.h>`

Inheritance diagram for hueplusplus::sensors::ZGPSwitch:
[legend]
Collaboration diagram for hueplusplus::sensors::ZGPSwitch:
[legend]

## Public Member Functions

| ZGPSwitch (Sensor sensor)
| Construct from generic sensor.
bool | isOn () const
| Check if sensor is on.
void | setOn (bool on)
| Enable or disable sensor.
int | getButtonEvent () const
| Get the code of the last switch event.
Public Member Functions inherited from hueplusplus::BaseDevice
virtual | ~BaseDevice ()=default
| Virtual destructor.
virtual int | getId () const
| Const function that returns the id of this device.
virtual std::string | getType () const
| Const function that returns the device type.
virtual std::string | getName ()
| Function that returns the name of the device.
virtual std::string | getName () const
| Const function that returns the name of the device.
virtual std::string | getModelId () const
| Const function that returns the modelid of the device.
virtual std::string | getUId () const
| Const function that returns the uniqueid of the device.
virtual std::string | getManufacturername () const
| Const function that returns the manufacturername of the device.
virtual std::string | getProductname () const
| Const function that returns the productname of the device.
virtual std::string | getSwVersion ()
| Function that returns the software version of the device.
virtual std::string | getSwVersion () const
| Const function that returns the software version of the device.
virtual bool | setName (const std::string &name)
| Function that sets the name of the device.
virtual void | refresh (bool force=false)
| Refreshes internal cached state.
virtual void | setRefreshDuration (std::chrono::steady_clock::duration refreshDuration)
| Sets custom refresh interval for this device.

## Static Public Attributes

static constexpr int | c_button1 = 34
| Code for tap button 1.
static constexpr int | c_button2 = 16
| Code for tap button 2.
static constexpr int | c_button3 = 17
| Code for tap button 3.
static constexpr int | c_button4 = 18
| Code for tap button 4.
static constexpr const char * | typeStr = "ZGPSwitch"
| ZGPSwitch sensor type name.

## Additional Inherited Members

Protected Member Functions inherited from hueplusplus::BaseDevice
| BaseDevice (int id, const std::shared_ptr< APICache > &baseCache)
| Protected ctor that is used by subclasses, construct with shared cache.
| BaseDevice (int id, const HueCommandAPI &commands, const std::string &path, std::chrono::steady_clock::duration refreshDuration, const nlohmann::json &currentState)
| Protected ctor that is used by subclasses.
virtual nlohmann::json | sendPutRequest (const std::string &subPath, const nlohmann::json &request, FileInfo fileInfo)
| Utility function to send a put request to the device.
Protected Attributes inherited from hueplusplus::BaseDevice
int | id
| holds the id of the device
APICache | state
| holds the current state of the device

## Detailed Description

ZigBee Green Power sensor for button presses.

## Constructor & Destructor Documentation

## ZGPSwitch()

hueplusplus::sensors::ZGPSwitch::ZGPSwitch | ( | Sensor | sensor | ) |

inline explicit

Construct from generic sensor.

## Member Function Documentation

## getButtonEvent()

int hueplusplus::sensors::ZGPSwitch::getButtonEvent | ( |  | ) | const

Get the code of the last switch event.

Possible values are c_button1 etc., or any other value.

## isOn()

bool hueplusplus::sensors::ZGPSwitch::isOn | ( |  | ) | const

Check if sensor is on.

Sensors which are off do not change their status

## setOn()

void hueplusplus::sensors::ZGPSwitch::setOn | ( | bool | on | ) |

Enable or disable sensor.

Exceptions

  std::system_error | when system or socket operations fail
  HueException | when response contained no body
  HueAPIResponseException | when response contains an error
  nlohmann::json::parse_error | when response could not be parsed

## Member Data Documentation

## c_button1

constexpr int hueplusplus::sensors::ZGPSwitch::c_button1 = 34

static constexpr

Code for tap button 1.

## c_button2

constexpr int hueplusplus::sensors::ZGPSwitch::c_button2 = 16

static constexpr

Code for tap button 2.

## c_button3

constexpr int hueplusplus::sensors::ZGPSwitch::c_button3 = 17

static constexpr

Code for tap button 3.

## c_button4

constexpr int hueplusplus::sensors::ZGPSwitch::c_button4 = 18

static constexpr

Code for tap button 4.

## typeStr

constexpr const char * hueplusplus::sensors::ZGPSwitch::typeStr = "ZGPSwitch"

static constexpr

ZGPSwitch sensor type name.

The documentation for this class was generated from the following files:

- include/hueplusplus/ZLLSensors.h
- src/ZLLSensors.cpp